## gnudatalanguage 0.9.7

=== CMakeLists.txt ===
#
# copyright : (c) 2010 Maxime Lenoir and Alain Coulais
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#

# tested with 2.4 and doesn't seem to run.
# SA: 2.6 supports simplified if constructs, e.g. endif()
cmake_minimum_required(VERSION 2.6 FATAL_ERROR)

project(GDL)

# X.X.X CVS becomes release X.X.X+1
set(VERSION "0.9.7")
enable_testing()

include(CheckIncludeFile)
include(CheckIncludeFileCXX)
include(CheckLibraryExists)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckCSourceRuns)
include(CheckCXXSourceCompiles)
include(FindPkgConfig)
include(FindPackageHandleStandardArgs)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/CMakeModules)

#### Default cached values
set(PYTHON_MODULE OFF CACHE BOOL "GDL: Build GDL as a Python module ?")

set(X11 ON CACHE BOOL "GDL: Enable X11 ?") 
set(X11DIR "" CACHE PATH "GDL: Specify X11 directory tree")

# GNU Readline or BSD Editline ? if Readline OK, we don't look for Editline.
set(READLINE ON CACHE BOOL "GDL: Enable GNU Readline ?")
set(READLINEDIR "" CACHE PATH "GDL: Specify the GNU Readline directory tree")

set(EDITLINE ON CACHE BOOL "GDL: Enable BSD Editline ?")
set(EDITLINEDIR "" CACHE PATH "GDL: Specify the BSD Editline directory tree")

set(OLDPLPLOT OFF CACHE BOOL "GDL: Enable old plplot ?")
set(PLPLOTDIR "" CACHE PATH "GDL: Specify the plplot directory tree")

set(GSLDIR "" CACHE PATH "GDL: Specify the GSL directory tree")

set(ZLIBDIR "" CACHE PATH "GDL: Specify the Zlib directory tree")

set(WXWIDGETS ON CACHE BOOL "GDL: Enable WxWidgets ?")
set(WXWIDGETSDIR "" CACHE PATH "GDL: Specify WxWidgets directory tree")

set(UDUNITS OFF CACHE BOOL "GDL: Enable UDUNITS-2 ?")
set(UDUNITSDIR "" CACHE PATH "GDL: Specify the UDUNITS-2 directory tree")

set(EIGEN3 ON CACHE BOOL "GDL: Enable Eigen3 ?")
set(EIGEN3DIR "" CACHE PATH "GDL: Specify the Eigen3 directory tree")

set(PSLIB ON CACHE BOOL "GDL: Enable pslib ?")
set(PSLIBDIR "" CACHE PATH "GDL: Specify the pslib directory tree")

set(PNGLIB ON CACHE BOOL "GDL: Enable libpng ?")
set(PNGLIBDIR "" CACHE PATH "GDL: Specify the libpng directory tree")

set(GRIB OFF CACHE BOOL "GDL: Enable Grib ?")
set(GRIBDIR "" CACHE PATH "GDL: Specifiy the GRIB directory tree")

set(QHULL OFF CACHE BOOL "GDL: Enable Qhull ?")
set(QHULLDIR "" CACHE PATH "GDL: Specifiy the QHULL directory tree")

# GraphicsMagick is a good alternative to ImageMagick, if GM OK, we don't look for IM
set(GRAPHICSMAGICK ON CACHE BOOL "GDL: Enable GraphicsMagick ?")
set(GRAPHICSMAGICKDIR "" CACHE PATH "GDL: Specify the GraphicsMagick directory tree")

set(MAGICK ON CACHE BOOL "GDL: Enable ImageMagick ?")
set(MAGICKDIR "" CACHE PATH "GDL: Specifiy the ImageMagick directory tree")

set(NETCDF ON CACHE BOOL "GDL: Enable NetCDF ?")
set(NETCDFDIR "" CACHE PATH "GDL: Specifiy the netCDF directory tree")

set(HDF ON CACHE BOOL "GDL: Enable Hdf ?")
set(HDFDIR "" CACHE PATH "GDL: Specifiy the HDF directory tree")

set(HDF5 ON CACHE BOOL "GDL: Enable Hdf5 ?")
set(HDF5DIR "" CACHE PATH "GDL: Specifiy the HDF5 directory tree")

set(FFTW ON CACHE BOOL "GDL: Enable FFTW ?")
set(FFTWDIR "" CACHE PATH "GDL: Specifiy the FFTW directory tree")

set(LIBPROJ4 OFF CACHE BOOL "GDL: Enable LIBPROJ4 ?")
set(LIBPROJ4DIR "" CACHE PATH "GDL: Specifiy the LIBPROJ4 directory tree")

set(MPICH OFF CACHE BOOL "GDL: Enable MPICH ?")
set(MPICHDIR "" CACHE PATH "GDL: Specify the MPICH (experimental) directory tree")

set(PYTHON ON CACHE BOOL "GDL: Enable Python ?")
set(PYTHONDIR "" CACHE PATH "GDL: Specifiy the use Python directory tree")
set(PYTHONVERSION "" CACHE STRING "GDL: Specify the Python version to use")

set(GSHHS ON CACHE BOOL "GDL: Enable GSHHS ?")
set(GSHHSDIR "" CACHE PATH "GDL: Specifiy the GSHHS directory tree")

if(NOT WIN32)
  set(NCURSESDIR "" CACHE PATH "GDL: Specify the ncurses (or curses) directory tree")
endif(NOT WIN32)

set(OPENMP ON CACHE BOOL "GDL: Enable OpenMP ?")

# Third party libraries
set(JASPERDIR "" CACHE PATH "GDL: Specify the JasPer directory tree")
set(JPEGDIR "" CACHE PATH "GDL: Specify the JPEG directory tree")
set(SZIPDIR "" CACHE PATH "GDL: Specify the SZip directory tree")

set(GDL_DATA_DIR "/share/gnudatalanguage" CACHE PATH "GDL: data directory relative to CMAKE_INSTALL_PREFIX")

# check for 64-bit OS
if(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
	set(HAVE_64BIT_OS 1)
endif(${CMAKE_SIZEOF_VOID_P} EQUAL 8)

#### check headers and libraries

# dl
check_library_exists(dl dlopen "" HAVE_DL)
if(HAVE_DL)
	set(LIBRARIES ${LIBRARIES} dl)
endif(HAVE_DL)

# malloc stats
check_function_exists(malloc_zone_statistics HAVE_MALLOC_ZONE_STATISTICS)
check_function_exists(sbrk HAVE_SBRK)
check_function_exists(mallinfo HAVE_MALLINFO)

# mallocs
check_include_file(malloc.h HAVE_MALLOC_H)
check_include_file(malloc/malloc.h HAVE_MALLOC_MALLOC_H)

# locale
check_include_file(locale.h HAVE_LOCALE_H)

# std includes..
check_include_file(stdint.h HAVE_STDINT_H)
check_include_file(stdlib.h HAVE_STDLIB_H)
check_include_file(string.h HAVE_STRING_H)
check_include_file(strings.h HAVE_STRINGS_H)
check_include_file(sys/stat.h HAVE_SYS_STAT_H)
check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(unistd.h HAVE_UNISTD_H)
#check_include_file(ext/stdio_filebuf.h HAVE_EXT_STDIO_FILEBUF_H)
#sometimes it compiles but stdio_filebuf is only in gcc-x-y-z directory tree...
# would be silly not to use this functionality if present, so recheck:
if (HAVE_EXT_STDIO_FILEBUF_H)
else (HAVE_EXT_STDIO_FILEBUF_H)
	check_cxx_source_compiles("
#include <ext/stdio_filebuf.h>
int main(int argc, char **argv) {
    int i=0;
    i+=1;
}" REALLY_HAVE_EXT_STDIO_FILEBUF_H)
endif (HAVE_EXT_STDIO_FILEBUF_H)
if (REALLY_HAVE_EXT_STDIO_FILEBUF_H)
message(STATUS "INFO: will use GNU extensions for STDIO (useful for compressed I/O) since it seems accepted by your c++ compiler.")
set (HAVE_EXT_STDIO_FILEBUF_H 1)
endif (REALLY_HAVE_EXT_STDIO_FILEBUF_H)
# dlfcn.h
check_include_file(dlfcn.h HAVE_DLFCN_H)

# inttypes.h
check_include_file(inttypes.h HAVE_INTTYPES_H)

# nexttoward
check_library_exists(m nexttoward "" HAVE_NEXTTOWARD)

# mpi
check_include_file(mpi.h HAVE_MPI_H)

# SA: whithout it compilation of antlr fails if there's a conflicting 
#     version of antlr in system-wide directories
include_directories(src)

if (NOT WIN32)
	# Ncurses MANDATORY for readline on POSIX
	# -DNCURSESDIR=DIR
	set(CMAKE_PREFIX_PATH ${NCURSESDIR})	
	set(CURSES_NEED_NCURSES TRUE)
	find_package(Curses QUIET COMPONENTS initscr)
	mark_as_advanced(CURSES_CURSES_H_PATH CURSES_FORM_LIBRARY CURSES_HAVE_CURSES_H)
	if(CURSES_FOUND)
		set(HAVE_LIBNCURSES 1)
		set(LIBRARIES ${LIBRARIES} ${CURSES_LIBRARIES})
		include_directories(${CURSES_INCLUDE_DIR})
	else(CURSES_FOUND)
		# search for curses
		set(CURSES_NEED_NCURSES FALSE)
		find_package(Curses COMPONENTS initscr)
		set(HAVE_LIBCURSES ${CURSES_FOUND})
		if(CURSES_FOUND)
			set(LIBRARIES ${LIBRARIES} ${CURSES_LIBRARIES})
			include_directories(${CURSES_INCLUDE_DIR})
		else(CURSES_FOUND)
			message(FATAL_ERROR "(N)Curses was not found.\n"
				"Use -DNCURSESDIR=DIR to specify the curses directory tree.\n"
				"(suitable Debian/Ubuntu package: libncurses-dev)\n")
		endif(CURSES_FOUND)
	endif(CURSES_FOUND)
endif (NOT WIN32)

# GNU Readline (GNU/Linux or OSX) or BSD Editline (OSX)

# -DREADLINE=ON|OFF
# -DREADLINEDIR=DIR or -DEDITLINEDIR=DIR
if(READLINE)
  set(CMAKE_PREFIX_PATH ${READLINEDIR})
  find_package(Readline QUIET)
  set(HAVE_LIBREADLINE ${READLINE_FOUND})
  if(READLINE_FOUND)
    if(NOT WIN32)
      # readline needs (n)curses (not on Windows)
      set(CMAKE_REQUIRED_LIBRARIES ${CURSES_LIBRARIES})
    endif(NOT WIN32)
    check_library_exists("${READLINE_LIBRARIES}" rl_get_screen_size "" RL_GET_SCREEN_SIZE)
    if(NOT RL_GET_SCREEN_SIZE)
      message(STATUS "WARNING: Older GNU readline without rl_get_screen_size was found.\n"
	"For resized terminals the size might not be updated correctly.\n"
	"If this is a problem please install a recent version of readline.")
    endif(NOT RL_GET_SCREEN_SIZE)
    set(LIBRARIES ${LIBRARIES} ${READLINE_LIBRARIES})
    include_directories(${READLINE_INCLUDE_DIR})
    set(CMAKE_REQUIRED_LIBRARIES)
  else(READLINE_FOUND)
    if(EDITLINE)
      message(STATUS "WARNING: GNU readline was not found, now looking for BSD Editline.\n")
    else(EDITLINE)
      message(FATAL_ERROR "GNU readline was not found.\n"
	"Use -DREADLINEDIR=no to explicitely disable it.\n"
	"(suitable Debian/Ubuntu package: libreadline-gplv2-dev)\n"
	"(suitable Fedora package: readline-devel)")
    endif(EDITLINE)    
  endif(READLINE_FOUND)
endif(READLINE)
#
# if Readline found, we do not look for Editline
#
if(READLINE_FOUND)
  if (EDITLINE)
    message(STATUS "INFO: We prefer to use Readline than Editline.\n"
      "Feedback welcome on OSX Readline ...")
    set(EDITLINE OFF)
  endif(EDITLINE)
endif(READLINE_FOUND)

# BSD Editline (a BSD clone of GNU Readline, present by default on OSX)
# -DEDITLINE=ON|OFF
# -DEDITLINEDIR=DIR
if(EDITLINE)
  set(CMAKE_PREFIX_PATH ${EDITLINEDIR})
  find_package(Editline QUIET)
  set(HAVE_LIBEDITLINE ${EDITLINE_FOUND})
  if(EDITLINE_FOUND)
    if(NOT WIN32)
      # readline needs (n)curses (not on Windows)
      set(CMAKE_REQUIRED_LIBRARIES ${CURSES_LIBRARIES})
    endif(NOT WIN32)
    set(LIBRARIES ${LIBRARIES} ${EDITLINE_LIBRARIES})
    include_directories(${EDITLINE_INCLUDE_DIR})
    set(CMAKE_REQUIRED_LIBRARIES)
  else(EDITLINE_FOUND)
    message(FATAL_ERROR "requested BSD Editline was not found.\n"
      "Use -DEDITLINE=no to explicitely disable it.\n")
  endif(EDITLINE_FOUND)
endif(EDITLINE)

# zlib MANDATORY
# -DZLIBDIR=DIR
set(CMAKE_PREFIX_PATH ${ZLIBDIR})
find_package(ZLIB QUIET)
set(HAVE_LIBZ ${ZLIB_FOUND})
if(ZLIB_FOUND)
	set(LIBRARIES ${LIBRARIES} ${ZLIB_LIBRARIES})
	include_directories(${ZLIB_INCLUDE_DIR})
else(ZLIB_FOUND)
	message(FATAL_ERROR "ZLib library is required but was not found.\n"
	"Use -DZLIBDIR=DIR to specify the zlib directory tree.\n"
        "(suitable Debian/Ubuntu package: zlib1g-dev)\n"
        "(suitable Fedora package: zlib-devel)")
endif(ZLIB_FOUND)

# libpng
# -DPNGLIB=ON|OFF
# -DPNGLIBDIR=DIR
if(PNGLIB)
	set(CMAKE_PREFIX_PATH ${PNGLIBDIR})
	find_package(PNG QUIET)
	set(USE_PNGLIB ${PNG_FOUND})
	if(PNG_FOUND)
		set(LIBRARIES ${LIBRARIES} ${PNG_LIBRARIES})
		set(LINK_DIRECTORIES ${LINK_DIRECTORIES} ${PNG_LIBRARY_DIRS})
		include_directories(${PNG_INCLUDE_DIRS})
	else(PNG_FOUND)
		message(FATAL_ERROR "libpng is required but was not found.\n"
		"Use -DPNGLIBDIR=DIR to specify the libpng directory tree.\n"
		"Use -DPNGLIB=OFF to not use it.\n"
                "(suitable Debian/Ubuntu package: libpng-dev)\n"
                "(suitable Fedora package: libpng-devel)")
	endif(PNG_FOUND)
endif(PNGLIB)

# openmp
# -DOPENMP=ON|OFF
if(OPENMP)
	find_package(OpenMP QUIET)
	if(OPENMP_FOUND)
		add_definitions(${OpenMP_CXX_FLAGS})
		if(MSVC)
			set(LIBRARIES ${LIBRARIES} vcomp)
		elseif(WIN32)
      set(LIBRARIES ${LIBRARIES} gomp pthread)
    else()
			set(LIBRARIES ${LIBRARIES} ${OpenMP_CXX_FLAGS})
		endif()
	endif(OPENMP_FOUND)
else(OPENMP)
  # we need to define those semaphore posix symbols, do it with threads libs
  find_package(Threads)
  if(THREADS_FOUND)
    set(LIBRARIES ${LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
  else(THREADS_FOUND)
    check_library_exists(rt sem_unlink "" HAVE_RT)
    if(HAVE_RT)
      set(LIBRARIES ${LIBRARIES} rt)
    else(HAVE_RT)
      message(FATAL_ERROR "Missing a POSIX semaphore symbols (rt or threads).\n")
    endif(HAVE_RT)
  endif(THREADS_FOUND)
endif(OPENMP)

# GSL MANDATORY
# -DGSLDIR=DIR
set(CMAKE_PREFIX_PATH ${GSLDIR})
find_package(GSL QUIET)
set(HAVE_LIBGSL ${GSL_FOUND})
set(HAVE_LIBGSLCBLAS ${GSL_FOUND})
if(GSL_FOUND)
	set(LIBRARIES ${LIBRARIES} ${GSL_LIBRARIES})
	include_directories(${GSL_INCLUDE_DIR})
else(GSL_FOUND)

=== src/CMakeLists.txt ===
set(SOURCES
CFMTLexer.cpp
CFMTLexer.hpp
CFMTTokenTypes.hpp
FMTIn.cpp
FMTIn.hpp
FMTInTokenTypes.hpp
FMTLexer.cpp
FMTLexer.hpp
FMTOut.cpp
FMTOut.hpp
FMTOutTokenTypes.hpp
FMTParser.cpp
FMTParser.hpp
FMTTokenTypes.hpp
GDLInterpreter.cpp
GDLInterpreter.hpp
GDLInterpreterTokenTypes.hpp
GDLLexer.cpp
GDLLexer.hpp
GDLParser.cpp
GDLParser.hpp
GDLTokenTypes.hpp
GDLTreeParser.cpp
GDLTreeParser.hpp
GDLTreeParserTokenTypes.hpp
accessdesc.hpp
allix.hpp
allix.cpp
arrayindex.cpp
arrayindex.hpp
arrayindexlistt.hpp
arrayindexlistnoassoct.hpp
assocdata.cpp
assocdata.hpp
basegdl.cpp
basegdl.hpp
basic_fun.cpp
basic_fun.hpp
basic_fun_cl.cpp
basic_fun_cl.hpp
basic_fun_jmg.cpp
basic_fun_jmg.hpp
basic_op.cpp
cformat.g
color.cpp
color.hpp
convert2.cpp
convol.cpp
convol_inc0.cpp
convol_inc1.cpp
convol_inc2.cpp
datalistt.hpp
datatypes.cpp
datatypes.hpp
datatypesref.cpp
dcommon.cpp
dcommon.hpp
dcompiler.cpp
dcompiler.hpp
default_io.cpp
deviceps.hpp
devicesvg.hpp
devicez.hpp
dimension.hpp
dialog.cpp
dialog.hpp
dinterpreter.cpp
dinterpreter.hpp
dnode.cpp
dnode.hpp
dnodefactory.hpp
dpro.cpp
dpro.hpp
dstructdesc.cpp
dstructdesc.hpp
dstructgdl.cpp
dstructgdl.hpp
dvar.cpp
dvar.hpp
envt.cpp
envt.hpp
extrat.cpp
extrat.hpp
fftw.cpp
fftw.hpp
file.cpp
file.hpp
fmtnode.cpp
fmtnode.hpp
format.g
format.in.g
format.out.g
gdlc.g
gdlc.i.g
gdlc.tree.g
gdleventhandler.cpp
gdleventhandler.hpp
gdlexception.cpp
gdlexception.hpp
gdlgstream.cpp
gdlgstream.hpp
)
if(WIN32)
set(SOURCES
${SOURCES}
gdlwinstream.cpp
gdlwinstream.hpp
gtdhelper.cpp
gtdhelper.hpp
devicewin.hpp
devicewin.cpp
)
else(WIN32)
set(SOURCES
${SOURCES}
devicex.hpp
gdlxstream.cpp
gdlxstream.hpp
)
endif(WIN32)
set(SOURCES
${SOURCES}
gdljournal.cpp
gdljournal.hpp
gdlpsstream.cpp
gdlpsstream.hpp
gdlpython.cpp
gdlpython.hpp
gdlsvgstream.cpp
gdlsvgstream.hpp
gdlwidget.cpp
gdlwidgeteventhandler.cpp
gdlwidget.hpp
gdlwxstream.cpp
gdlwxstream.hpp
gdlzstream.cpp
gdlzstream.hpp
getfmtast.cpp
getfmtast.hpp
graphicsdevice.cpp
graphicsdevice.hpp
basic_pro.cpp
basic_pro.hpp
basic_pro_jmg.cpp
basic_pro_jmg.hpp
grib.cpp
grib.hpp
gshhs.cpp
gshhs.hpp
gsl_fun.cpp
gsl_fun.hpp
gsl_matrix.cpp
gsl_matrix.hpp
gzstream.hpp
hash.cpp
hash.hpp
hdf5_fun.cpp
hdf5_fun.hpp
hdf_fun.cpp
hdf_fun.hpp
hdf_pro.cpp
hdf_pro.hpp
ifmt.cpp
image.cpp
image.hpp
initct.cpp
initsysvar.cpp
initsysvar.hpp
io.cpp
io.hpp
lapack.cpp
least_squares.cpp
least_squares.hpp
libinit.cpp
libinit_ac.cpp
libinit_cl.cpp
libinit_gm.cpp
libinit_jmg.cpp
libinit_mes.cpp
libinit_ng.cpp
libinit_jp.cpp
list.cpp
list.hpp
magick_cl.cpp
magick_cl.hpp
math_fun.cpp
math_fun.hpp
math_fun_ac.cpp
math_fun_ac.hpp
math_fun_gm.cpp
math_fun_gm.hpp
math_fun_jmg.cpp
math_fun_jmg.hpp
math_fun_ng.cpp
math_fun_ng.hpp
math_utl.cpp
math_utl.hpp
matrix_cholesky.cpp
matrix_cholesky.hpp
matrix_invert.cpp
matrix_invert.hpp
mpi.cpp
mpi.hpp
ncdf_att_cl.cpp
ncdf_cl.cpp
ncdf_cl.hpp
ncdf_dim_cl.cpp
ncdf_var_cl.cpp
ncdf4_group.cpp
new.cpp
new.hpp
newprognode.cpp
nullgdl.cpp
nullgdl.hpp
objects.cpp
objects.hpp
ofmt.cpp
ofmt.hpp
overload.cpp
overload.hpp
plotting_axis.cpp
plotting_contour.cpp
plotting_convert_coord.cpp
plotting_cursor.cpp
plotting_device.cpp
plotting_erase.cpp
plotting_image.cpp
plotting_map_proj.cpp
plotting_misc.cpp
plotting_oplot.cpp
plotting_plot.cpp
plotting_plots.cpp
plotting_polyfill.cpp
plotting_shade_surf.cpp
plotting_surface.cpp
plotting_windows.cpp
plotting_xyouts.cpp
plotting.cpp
plotting.hpp
print.cpp
print_tree.cpp
print_tree.hpp
prognode.cpp
prognode_lexpr.cpp
prognodeexpr.cpp
read.cpp
real2int.hpp
semshm.cpp
semshm.hpp
sigfpehandler.cpp
sigfpehandler.hpp
#smooth.cpp
#smooth.hpp
specializations.hpp
str.cpp
str.hpp
strassenmatrix.hpp
terminfo.cpp
terminfo.hpp
topython.cpp
typedefs.hpp
typetraits.cpp
typetraits.hpp
widget.cpp
widget.hpp
)

add_subdirectory(antlr)

include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/antlr ${CMAKE_BINARY_DIR})
link_directories(${LINK_DIRECTORIES})

if(PYTHON_MODULE) #GDL.so
	set(SOURCES ${SOURCES} pythongdl.cpp)
	add_library(gdl SHARED ${SOURCES})
	SET_TARGET_PROPERTIES(gdl PROPERTIES PREFIX "")
	SET_TARGET_PROPERTIES(gdl PROPERTIES OUTPUT_NAME GDL)
	SET_TARGET_PROPERTIES(gdl PROPERTIES NO_SONAME TRUE)
else(PYTHON_MODULE) #GDL.so
	set(SOURCES ${SOURCES} gdl.cpp)
	add_executable(gdl ${SOURCES})
endif(PYTHON_MODULE)

add_dependencies(gdl antlr) # be sure that antlr is built before gdl
target_link_libraries(gdl antlr) # link antlr against gdl
if (MINGW)
target_link_libraries(gdl ws2_32)
endif (MINGW)
target_link_libraries(gdl ${LIBRARIES})
add_definitions(-DHAVE_CONFIG_H)

if(PYTHON_MODULE)
	find_package( PythonInterp REQUIRED )
	execute_process(COMMAND ${PYTHON_EXECUTABLE} -c
		"import site, sys; sys.stdout.write(site.PREFIXES[-1])"
			OUTPUT_VARIABLE PYTHON_PREFIX)
	file( TO_CMAKE_PATH "${PYTHON_PREFIX}" PYTHON_PREFIX)
        execute_process(COMMAND ${PYTHON_EXECUTABLE} -c
		"import site, sys; sys.stdout.write(site.getsitepackages()[-1])"
			OUTPUT_VARIABLE PYTHON_SITE_DIR)
	file( TO_CMAKE_PATH "${PYTHON_SITE_DIR}" PYTHON_SITE_DIR )
	string( REGEX REPLACE "^${PYTHON_PREFIX}/" ""
	       PYTHON_SITE_DIR "${PYTHON_SITE_DIR}")
	install(TARGETS gdl DESTINATION ${PYTHON_SITE_DIR})
else(PYTHON_MODULE)
	install(TARGETS gdl DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
	set_target_properties(gdl PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
endif(PYTHON_MODULE)

install(DIRECTORY ${CMAKE_SOURCE_DIR}/src/pro/ DESTINATION ${CMAKE_INSTALL_PREFIX}/${GDL_DATA_DIR}/lib
	PATTERN CVS EXCLUDE
	PATTERN checks EXCLUDE
	PATTERN Makefile* EXCLUDE
	PATTERN UrgentNeed.txt EXCLUDE)

=== testsuite/CMakeLists.txt ===
set(BASE_SOURCE ${CMAKE_SOURCE_DIR})
set(BASE_BINARY ${CMAKE_BINARY_DIR})
# write the test launcher
if(WIN32 AND NOT CYGWIN)
set(LAUNCH
"#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <malloc.h>
#ifndef _MSC_VER
#include <unistd.h>
#endif
int main(int c,char**v) {
char*p;
if(c!=2) return 1;
for(p=v[1];*p;++p);
if(p-4<v[1]) return 1;
if(p[-1]!='o'||p[-2]!='r'||p[-3]!='p'||p[-4]!='.') return 1;
*(p-4)=0;

_putenv(\"LC_COLLATE=C\");
_putenv(\"GDL_PATH=${BASE_SOURCE}/testsuite/;${BASE_SOURCE}/src/pro/\");
_putenv(\"GDL_STARTUP=\");
_putenv(\"IDL_STARTUP=\");

char *tmp = (char *)malloc( sizeof(char) * (strlen(\"${BASE_BINARY}/src/gdl -quiet -e \") + strlen(v[1]) + 1));
//PROCESS_INFORMATION processInformation = {0};
//STARTUPINFO startupInfo                = {0};
//startupInfo.cb                         = sizeof(startupInfo);
sprintf(tmp, \"${BASE_BINARY}/src/gdl.exe -quiet -e %s\", v[1]);
//int rtn = CreateProcess(NULL, tmp, NULL, NULL, TRUE, 0, NULL, NULL, &startupInfo, &processInformation);
int rtn = system(tmp);

if (rtn == 77) {
    printf(\"TEST SKIPPED\");
    exit(0);
} if (rtn == -1 || rtn == 127) {
    printf(\"LAUNCH PROCESS FAILED\");
    exit(1);
} else {
    exit(rtn);
}
}
")
else(WIN32 AND NOT CYGWIN)
set(LAUNCH
"#include<unistd.h>
#include<stdlib.h>
#include<stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/wait.h>
#include<sched.h>
int main(int c,char**v) {
char*p;
if(c!=2) return 1;
for(p=v[1];*p;++p);
if(p-4<v[1]) return 1;
if(p[-1]!='o'||p[-2]!='r'||p[-3]!='p'||p[-4]!='.') return 1;
*(p-4)=0;
setenv(\"LC_COLLATE\",\"C\",1);
setenv(\"GDL_PATH\",\"+${BASE_SOURCE}/testsuite/:+${BASE_SOURCE}/src/pro/\",1);
unsetenv(\"GDL_STARTUP\");
unsetenv(\"IDL_STARTUP\");
int devnull = open(\"/dev/null\",O_RDONLY);
dup2(devnull, 0);
int child_pid = fork();
if(child_pid == 0) {
  execl(\"${BASE_BINARY}/src/gdl\",\"-quiet\",\"-e\",v[1],(char*)0);
  exit(1);
} else {
  sched_yield();
  int child_status;
  waitpid(child_pid, &child_status, 0);
  if (WEXITSTATUS(child_status) == 77) {
    printf(\"TEST SKIPPED\");
    exit(0);
  } else if (WIFSIGNALED(child_status)) {
    printf(\"TEST EXITED FROM SIGNAL %d\", WTERMSIG(child_status));
    exit(1);
  } else {
    exit(WEXITSTATUS(child_status));
  }
}
}
")
endif(WIN32 AND NOT CYGWIN)
file(WRITE ${CMAKE_SOURCE_DIR}/testsuite/launchtest.c "${LAUNCH}")
add_executable(launchtest EXCLUDE_FROM_ALL ${CMAKE_SOURCE_DIR}/testsuite/launchtest.c)
add_library(test_ce SHARED EXCLUDE_FROM_ALL libtest_ce.cpp)
add_custom_target(check COMMAND ${CMAKE_BUILD_TOOL} test DEPENDS launchtest test_ce gdl)
get_target_property(LAUNCHTESTLOCATION launchtest LOCATION)
if(WIN32 AND NOT CYGWIN)
  file(READ "${BASE_SOURCE}/testsuite/Makefile.am" MAKEFILEAM)
  string(REGEX MATCHALL "test[_a-zA-Z0-9]+\\.pro" TESTS ${MAKEFILEAM})
else(WIN32 AND NOT CYGWIN)
  execute_process(
    COMMAND "fgrep" ".pro" "${BASE_SOURCE}/testsuite/Makefile.am" 
    COMMAND "awk" "{printf(\"%s;\",$1)}" 
    OUTPUT_VARIABLE TESTS)
endif(WIN32 AND NOT CYGWIN)
foreach(TEST ${TESTS})
	add_test(${TEST} ${LAUNCHTESTLOCATION} ${TEST})
	set_tests_properties(${TEST} PROPERTIES SKIP_RETURN_CODE 77) # autoconf's setting
endforeach(TEST TESTS)

=== debian/changelog ===
gnudatalanguage (0.9.7-6) unstable; urgency=low

  * Allow stderr in CI test

 -- Ole Streicher <olebole@debian.org>  Fri, 27 Oct 2017 11:47:39 -0300

gnudatalanguage (0.9.7-5) unstable; urgency=low

  * Suppress warnings about security risk with tmpnam to fix test failures
  * Remove optional dependency on libhdf5-serial-dev (Closes: #879136)

 -- Ole Streicher <olebole@debian.org>  Tue, 24 Oct 2017 17:02:01 -0300

gnudatalanguage (0.9.7-4) unstable; urgency=medium

  * Also remove reference to plplot12-driver-xwin in
    debian/test/control. Thanks Ole Streicher!
  * debian/copyright: Switch format URL to HTTPS.
  * Declare compliance with Debian Policy 4.1.1. (No changes needed.)

 -- Axel Beckert <abe@debian.org>  Thu, 28 Sep 2017 23:11:03 +0200

gnudatalanguage (0.9.7-3) unstable; urgency=medium

  * Transition to the new plplot binary package names.
    + Update package relations where necessary. (Closes: #876858)
    + Bump libplplot-dev build-dependency to >= 5.13.0+dfsg-~ as the new
      plplot-driver-xwin build-dependency already implies that minimum
      version and the alternative build-dependency is no more satisfiable.
  * Declare compliance with Debian Policy 4.1.0.
    + Change priority from extra to optional.
  * Remove no more necessary Testsuite header. Thanks Lintian!
  * Replace usage of dpkg-parsechangelog with /usr/share/dpkg/pkg-info.mk,
    $(SOURCE_DATE_EPOCH) and $(DEB_VERSION). Thanks Lintian!
  * Bump debhelper compatibility to 10.
    + Update versioned debhelper build-dependency accordingly.
    + Drop explicit --parallel option from debian/rules.

 -- Axel Beckert <abe@debian.org>  Wed, 27 Sep 2017 00:51:41 +0200

gnudatalanguage (0.9.7-2) unstable; urgency=medium

  * Revert an upstream patch that causes trouble with multidimensional
    arrays. (Closes: #852682)
  * Adjust failing CI tests
  * Include PYTHON.txt in documentation

 -- Ole Streicher <olebole@debian.org>  Thu, 02 Feb 2017 10:02:21 +0100

gnudatalanguage (0.9.7-1) unstable; urgency=low

  * New upstream version 0.9.7. Switch back to unstable
  * Enable qhull
  * Rediff patches

 -- Ole Streicher <olebole@debian.org>  Sun, 22 Jan 2017 10:26:18 +0100

gnudatalanguage (0.9.7~rc2-1) experimental; urgency=medium

  * New upstream version 0.9.7~rc2
  * Rediff patches
  * Don't exclude blocking patches (fixed upstream)

 -- Ole Streicher <olebole@debian.org>  Wed, 11 Jan 2017 10:21:18 +0100

gnudatalanguage (0.9.7~rc1-1) experimental; urgency=medium

  * New upstream release candidate 0.9.7~rc1
  * Upload to experimental.
  * Adjust patches.

 -- Ole Streicher <olebole@debian.org>  Fri, 06 Jan 2017 16:47:11 +0100

gnudatalanguage (0.9.6v2-4) unstable; urgency=medium

  [ Axel Beckert ]
  * Move myself to the end of the Uploaders list.
  * Declare compliance with Debian Policy 3.9.8. (No changes needed.)
  * Switch Vcs-Git header from git:// to https://.
  * Enable all hardening flags.
  * Add lintian override since a variable name isn't a spelling error.
  * Switch SF URL in debian/patches/gdl-fun-fix from http:// to https://
    as suggested by DUCK.
  * Add DEP3 patch headers to debian/patches/hdf5-1.10.patch.
  * Add yet another spelling error found by lintian to
    debian/patches/fix-spelling-errors.

  [ Ole Streicher ]
  * Set "Multi-Arch: same" for libgnudatalanguage0 and python-gdl as
    suggested by the MultiArch hinter.

 -- Axel Beckert <abe@debian.org>  Tue, 03 Jan 2017 11:51:09 +0100

gnudatalanguage (0.9.6v2-3.1) unstable; urgency=medium

  * Non-maintainer upload
  * New patch to support HDF5 1.10 (closes: #841971)

 -- Gilles Filippini <pini@debian.org>  Sun, 30 Oct 2016 20:35:45 +0100

gnudatalanguage (0.9.6v2-3) unstable; urgency=medium

  * Another patch for gcc-6 compatibility

 -- Ole Streicher <olebole@debian.org>  Fri, 01 Jul 2016 13:20:16 +0200

gnudatalanguage (0.9.6v2-2) unstable; urgency=medium

  * Add d/u/metadata
  * Fix gcc-6 compilation error. Closes: #811918

 -- Ole Streicher <olebole@debian.org>  Thu, 30 Jun 2016 09:35:53 +0200

=== debian/control ===
Source: gnudatalanguage
Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Ole Streicher <olebole@debian.org>,
           Axel Beckert <abe@debian.org>
Section: interpreters
Priority: optional
Build-Depends: cmake,
               debhelper (>= 10~),
               dpkg-dev (>= 1.16.1~),
               libantlr-dev,
               libeigen3-dev (>= 3.2.4),
               libeigen3-dev (>= 3.3~alpha1-3) [arm64],
               libfftw3-dev,
               libgraphicsmagick++1-dev,
               libgrib-api-dev,
               libgsl-dev,
               libhdf4-alt-dev,
               libhdf5-dev,
               libncurses-dev,
               libnetcdf-dev,
               libplplot-dev (>= 5.13.0+dfsg-~),
               libqhull-dev,
               libreadline-dev,
               libudunits2-dev,
               libwxgtk3.0-dev,
               plplot-driver-xwin,
               pslib-dev,
               python-dev,
               python-numpy,
               xauth,
               xvfb,
               zlib1g-dev
Standards-Version: 4.1.1
Homepage: http://gnudatalanguage.sourceforge.net/
Vcs-Git: https://anonscm.debian.org/git/debian-astro/packages/gnudatalanguage.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-astro/packages/gnudatalanguage.git

Package: libgnudatalanguage0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: gnudatalanguage (<< 0.9.5-7~)
Replaces: gnudatalanguage (<< 0.9.5-7~)
Description: Free IDL compatible incremental compiler shared library
 GNU Data Language (GDL) is a free IDL (Interactive Data Language)
 compatible incremental compiler. It has full syntax compatibility
 with IDL 7.1. IDL is a registered trademark of ITT Visual Information
 Solutions.
 .
 This package contains the shared library which is used by the different
 frontends (gdl binary, Python package).

Package: gnudatalanguage
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: plplot-driver-xwin,
            python-numpy
Description: Free IDL compatible incremental compiler
 GNU Data Language (GDL) is a free IDL (Interactive Data Language)
 compatible incremental compiler. It has full syntax compatibility
 with IDL 7.1. IDL is a registered trademark of ITT Visual Information
 Solutions. From IDL 8.0, the following language elements are
 supported:
 .
  * FOREACH loop
  * negative array indices
  * garbage collection pointers and objects
  * call methods on an object using "." (e. g. `object.aMemberProcedure,arg1`)
 .
 The file input output system is fully implemented. GUI support (widgets) is
 officially provided, but it's not complete yet.
 .
 This package contains the main commandline and interpreter frontend.

Package: python-gdl
Architecture: any
Multi-Arch: same
Section: python
Depends: python,
         python-numpy,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: plplot-driver-xwin
Description: Python interface for the GNU Data Language
 GNU Data Language (GDL) is a free IDL (Interactive Data Language)
 compatible incremental compiler. It has full syntax compatibility
 with IDL 7.1. IDL is a registered trademark of ITT Visual Information
 Solutions. From IDL 8.0, the following language elements are
 supported:
 .
  * FOREACH loop
  * negative array indices
  * garbage collection pointers and objects
  * call methods on an object using "." (e. g. `object.aMemberProcedure,arg1`)
 .
 The file input output system is fully implemented. GUI support (widgets) is
 officially provided, but it's not complete yet.
 .
 This package contains the Python library/interface.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CXXFLAGS += -DBUILD_DATE="\"$(shell LC_ALL=C date -u --date=@"$(SOURCE_DATE_EPOCH)" +'%b %e %Y')\""

%:
	dh $@ -Scmake

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DDEB_BUILD_MULTIARCH=`dpkg-architecture -qDEB_BUILD_MULTIARCH` \
	  -DFFTW=YES \
	  -DPYTHON=YES \
	  -DPYTHON_MODULE=YES \
	  -DWXWIDGETS=YES \
	  -DGRIB=YES \
	  -DQHULL=YES \
	  -DUDUNITS=YES \
	  -DPSLIB=YES

override_dh_auto_test:
	( cd obj*/testsuite \
	&& cp ../../testsuite/formats.idl . \
	&& $(CXX) -o libtest_ce.so ../../testsuite/libtest_ce.cpp -shared -fPIC \
	&& $(CC) -o launchtest ../../testsuite/launchtest.c )
	LD_LIBRARY_PATH="../src" xvfb-run dh_auto_test --no-parallel -Scmake || true

override_dh_compress:
	dh_compress -X.pro

# The epoch in front of python-gdl's version number is needed since
# Debian Squeeze had a python-gdl binary package with version 2.25.3-7
# built from the gnome-python-extras source package.
override_dh_gencontrol:
	dh_gencontrol -ppython-gdl -- -v1:$(DEB_VERSION)
	dh_gencontrol --remaining

=== debian/tests/control ===
Tests: test-gdl
Depends: gnudatalanguage, xauth, xvfb, plplot-driver-xwin
Restrictions: allow-stderr

Tests: test-GDL.py
Depends: python-gdl, python-pytest

=== debian/watch ===
version=3
opts=uversionmangle=s/(pre|rc)([^.]*)/~$1$2/ \
 http://sf.net/gnudatalanguage/gdl-(.*)\.t(?:ar\.)?.z

## gnudatalanguage 0.9.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
 project(GDL)
 
 # X.X.X CVS becomes release X.X.X+1
-set(VERSION "0.9.7")
+set(VERSION "0.9.8")
 enable_testing()
 
 include(CheckIncludeFile)
@@ -69,6 +69,9 @@
 
 set(QHULL OFF CACHE BOOL "GDL: Enable Qhull ?")
 set(QHULLDIR "" CACHE PATH "GDL: Specifiy the QHULL directory tree")
+
+set(GLPK OFF CACHE BOOL "GDL: Enable GLPK (for function SIMPLEX) ?")
+set(GLPKDIR "" CACHE PATH "GDL: Specify the GLPK directory tree")
 
 # GraphicsMagick is a good alternative to ImageMagick, if GM OK, we don't look for IM
 set(GRAPHICSMAGICK ON CACHE BOOL "GDL: Enable GraphicsMagick ?")
@@ -310,17 +313,18 @@
 # openmp
 # -DOPENMP=ON|OFF
 if(OPENMP)
-	find_package(OpenMP QUIET)
-	if(OPENMP_FOUND)
-		add_definitions(${OpenMP_CXX_FLAGS})
-		if(MSVC)
-			set(LIBRARIES ${LIBRARIES} vcomp)
-		elseif(WIN32)
+  find_package(OpenMP QUIET)
+  set(USE_OPENMP ${OPENMP_FOUND})
+  if(OPENMP_FOUND)
+    add_definitions(${OpenMP_CXX_FLAGS})
+    if(MSVC)
+      set(LIBRARIES ${LIBRARIES} vcomp)
+    elseif(WIN32)
       set(LIBRARIES ${LIBRARIES} gomp pthread)
     else()
-			set(LIBRARIES ${LIBRARIES} ${OpenMP_CXX_FLAGS})
-		endif()
-	endif(OPENMP_FOUND)
+      set(LIBRARIES ${LIBRARIES} ${OpenMP_CXX_FLAGS})
+    endif()
+  endif(OPENMP_FOUND)
 else(OPENMP)
   # we need to define those semaphore posix symbols, do it with threads libs
   find_package(Threads)
@@ -339,10 +343,3 @@
 # GSL MANDATORY
 # -DGSLDIR=DIR
 set(CMAKE_PREFIX_PATH ${GSLDIR})
-find_package(GSL QUIET)
-set(HAVE_LIBGSL ${GSL_FOUND})
-set(HAVE_LIBGSLCBLAS ${GSL_FOUND})
-if(GSL_FOUND)
-	set(LIBRARIES ${LIBRARIES} ${GSL_LIBRARIES})
-	include_directories(${GSL_INCLUDE_DIR})
-else(GSL_FOUND)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -24,6 +24,9 @@
 GDLTreeParser.cpp
 GDLTreeParser.hpp
 GDLTreeParserTokenTypes.hpp
+datatypes.cpp
+datatypes.hpp
+datatypesref.cpp
 accessdesc.hpp
 allix.hpp
 allix.cpp
@@ -42,18 +45,14 @@
 basic_fun_jmg.cpp
 basic_fun_jmg.hpp
 basic_op.cpp
+calendar.hpp
+calendar.cpp
 cformat.g
 color.cpp
 color.hpp
 convert2.cpp
 convol.cpp
-convol_inc0.cpp
-convol_inc1.cpp
-convol_inc2.cpp
 datalistt.hpp
-datatypes.cpp
-datatypes.hpp
-datatypesref.cpp
 dcommon.cpp
 dcommon.hpp
 dcompiler.cpp
@@ -82,6 +81,8 @@
 envt.hpp
 extrat.cpp
 extrat.hpp
+exists_fun.cpp
+exists_fun.hpp
 fftw.cpp
 fftw.hpp
 file.cpp
@@ -123,6 +124,7 @@
 ${SOURCES}
 gdljournal.cpp
 gdljournal.hpp
+gdlhelp.cpp
 gdlpsstream.cpp
 gdlpsstream.hpp
 gdlpython.cpp
@@ -144,6 +146,7 @@
 basic_pro.hpp
 basic_pro_jmg.cpp
 basic_pro_jmg.hpp
+brent.cpp
 grib.cpp
 grib.hpp
 gshhs.cpp
@@ -180,6 +183,8 @@
 libinit_mes.cpp
 libinit_ng.cpp
 libinit_jp.cpp
+libinit_exists.cpp
+linearprogramming.cpp
 list.cpp
 list.hpp
 magick_cl.cpp
@@ -246,19 +251,20 @@
 prognodeexpr.cpp
 read.cpp
 real2int.hpp
+saverestore.cpp
 semshm.cpp
 semshm.hpp
 sigfpehandler.cpp
 sigfpehandler.hpp
-#smooth.cpp
-#smooth.hpp
+smooth.cpp
+smooth.hpp
 specializations.hpp
 str.cpp
 str.hpp
-strassenmatrix.hpp
 terminfo.cpp
 terminfo.hpp
 topython.cpp
+triangulation.cpp
 typedefs.hpp
 typetraits.cpp
 typetraits.hpp

=== debian/changelog ===
gnudatalanguage (0.9.8-5) unstable; urgency=low

  * Use altivec __vector to not conflict with std C vector template
  * Push Standards-Version to 4.1.4. No changes needed.

 -- Ole Streicher <olebole@debian.org>  Tue, 22 May 2018 10:44:16 +0200

gnudatalanguage (0.9.8-4) unstable; urgency=low

  * Rediff patches

 -- Ole Streicher <olebole@debian.org>  Tue, 24 Apr 2018 17:57:17 +0200

gnudatalanguage (0.9.8-3) unstable; urgency=low

  * Avoid OOM errors while compiling on mips (Closes: #895471)
  * Disable specialized code that causes problems on powerpc (Closes: #894324)

 -- Ole Streicher <olebole@debian.org>  Tue, 24 Apr 2018 11:46:10 +0200

gnudatalanguage (0.9.8-2) unstable; urgency=low

  * Specify C++ standard in compilation
  * Get display properties only when display exists. Fixes Python CI failure
  * Add more failing tests

 -- Ole Streicher <olebole@debian.org>  Tue, 03 Apr 2018 14:32:05 +0200

gnudatalanguage (0.9.8-1) unstable; urgency=low

  [ Axel Beckert ]
  * Set "Rules-Requires-Root: no".
  * Declare compliance with Debian Policy 4.1.3. (No changes needed.)
  * Bump debhelper compatibility to 11.
    + Update versioned debhelper build-dependency accordingly.
  * Remove trailing whitespace from ancient debian/changelog entry.
  * Extend debian/patches/fix-spelling-errors to fix some more errors.

  [ Ole Streicher ]
  * Update VCS fields to use salsa.d.o
  * Restructure patches for use with gbp pq
  * New upstream version 0.9.8. Rediff patches
  * Change upstream repository to github
  * Use https in URLs
  * Add lintian-overrides for undafe symlink
  * Add $(filter nocheck,$(DEB_BUILD_OPTIONS)) to override_dh_auto_test

 -- Ole Streicher <olebole@debian.org>  Tue, 27 Mar 2018 12:14:50 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Section: interpreters
 Priority: optional
 Build-Depends: cmake,
-               debhelper (>= 10~),
+               debhelper (>= 11~),
                dpkg-dev (>= 1.16.1~),
                libantlr-dev,
                libeigen3-dev (>= 3.2.4),
@@ -30,10 +30,11 @@
                xauth,
                xvfb,
                zlib1g-dev
-Standards-Version: 4.1.1
-Homepage: http://gnudatalanguage.sourceforge.net/
-Vcs-Git: https://anonscm.debian.org/git/debian-astro/packages/gnudatalanguage.git
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-astro/packages/gnudatalanguage.git
+Standards-Version: 4.1.4
+Homepage: https://gnudatalanguage.sourceforge.net/
+Vcs-Git: https://salsa.debian.org/debian-astro-team/gnudatalanguage.git
+Vcs-Browser: https://salsa.debian.org/debian-astro-team/gnudatalanguage
+Rules-Requires-Root: no
 
 Package: libgnudatalanguage0
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,13 @@
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
-CXXFLAGS += -DBUILD_DATE="\"$(shell LC_ALL=C date -u --date=@"$(SOURCE_DATE_EPOCH)" +'%b %e %Y')\""
+CXXFLAGS += -DBUILD_DATE="\"$(shell LC_ALL=C date -u --date=@"$(SOURCE_DATE_EPOCH)" +'%b %e %Y')\"" -std=gnu++11
+
+# taken from https://bugs.debian.org/895214
+# less debug info to avoid running out of address space
+ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel))
+  export CXXFLAGS += -g1
+endif
 
 %:
 	dh $@ -Scmake
@@ -22,11 +28,13 @@
 	  -DPSLIB=YES
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	( cd obj*/testsuite \
 	&& cp ../../testsuite/formats.idl . \
 	&& $(CXX) -o libtest_ce.so ../../testsuite/libtest_ce.cpp -shared -fPIC \
 	&& $(CC) -o launchtest ../../testsuite/launchtest.c )
 	LD_LIBRARY_PATH="../src" xvfb-run dh_auto_test --no-parallel -Scmake || true
+endif
 
 override_dh_compress:
 	dh_compress -X.pro
